function[MatFin] = gameoflife(Mat) %Jeu de la vie, sans utiliser le décalage et l'addition de matrices

m = size(Mat,1); 
n = size(Mat,2);
MatFin = zeros(m,n);

% Test aux coins
A = Mat(1:2,1:2); B = Mat(1:2,n); C = Mat(m,1:2); D = Mat(m,n); % Haut gauche
if Mat(1,1) == 0
    if testngb([D C;B A]) == 3
        MatFin(1,1) = 1;
    end
end
if Mat(1,1) == 1
    if testngb([D C;B A]) == 3 || testngb([D C;B A]) == 4
        MatFin(1,1) = 1;
    end
end
if Mat(m,n) == 0 % bas droite
    if testngb([A B;C D]) == 3
        MatFin(m,n) = 1;
    end
end
if Mat(m,n) == 1
    if testngb([A B;C D]) == 3 || testngb([A B;C D]) == 4
        MatFin(m,n) = 1;
    end
end
A = Mat(1:2,1); B = Mat(1:2,n-1:n); C = Mat(m,1); D = Mat(m,n-1:n); % Haut droite
if Mat(1,n) == 0
    if testngb([D C;B A]) == 3
        MatFin(1,n) = 1;
    end
end
if Mat(1,n) == 1
    if testngb([D C;B A]) == 3 || testngb([D C;B A]) == 4
        MatFin(1,n) = 1;
    end
end
if Mat(m,1) == 0 % Bas gauche
    if testngb([A B;C D]) == 3
        MatFin(m,1) = 1;
    end
end
if Mat(m,1) == 1
    if testngb([A B;C D]) == 3 || testngb([A B;C D]) == 4
        MatFin(m,1) = 1;
    end
end

% Test sur les bords
for j = 2 : m-1 % haut
    A = Mat(m,j-1:j+1); B = Mat(1:2,j-1:j+1);
    if Mat(1,j) == 0
        if testngb([A ; B]) == 3
            MatFin(1,j) = 1;
        end
    end
    if Mat(1,j) == 1
        if testngb([A ; B]) == 3 || testngb([A ; B]) == 4
            MatFin(1,j) = 1;
        end
    end
end
for j = 2 : m-1 % bas
    A = Mat(m-1:m,j-1:j+1); B = Mat(1,j-1:j+1);
    if Mat(m,j) == 0
        if testngb([A ; B]) == 3
            MatFin(m,j) = 1;
        end
    end
    if Mat(m,j) == 1
        if testngb([A ; B]) == 3 || testngb([A ; B]) == 4
            MatFin(m,j) = 1;
        end
    end
end
for j = 2 : n-1 % gauche
    A = Mat(j-1:j+1,n); B = Mat(j-1:j+1,1:2);
    if Mat(j,1) == 0
        if testngb([A B]) == 3
            MatFin(j,1) = 1;
        end
    end
    if Mat(j,1) == 1
        if testngb([A B]) == 3 || testngb([A B]) == 4
            MatFin(j,1) = 1;
        end
    end
end
for j = 2 : n-1 % droite
    A = Mat(j-1:j+1,n-1:n); B = Mat(j-1:j+1,1);
    if Mat(j,n) == 0
        if testngb([A B]) == 3
            MatFin(j,n) = 1;
        end
    end
    if Mat(j,n) == 1
        if testngb([A B]) == 3 || testngb([A B]) == 4
            MatFin(j,n) = 1;
        end
    end
end

% Test à l'intérieur des bords
for j = 2 : m-1
    for k = 2 : n-1
        if Mat(j,k) == 0
            if testngb(Mat(j-1:j+1,k-1:k+1)) == 3
                MatFin(j,k) = 1;
            end
        end
        if Mat(j,k) == 1
            if testngb(Mat(j-1:j+1,k-1:k+1)) == 3 || testngb(Mat(j-1:j+1,k-1:k+1)) == 4
                MatFin(j,k) = 1;
            end
        end
    end
end

imagesc(MatFin)
colorbar
pause on
pause(0.05)
pause off